poj1952BUY LOW, BUY LOWER

BUY LOW, BUY LOWER
Time Limit: 1000MS Memory Limit: 30000K
Total Submissions: 10882 Accepted: 3816

Description

The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: 
                    "Buy low; buy lower"

Each time you buy a stock, you must purchase it at a lower price than the previous time you bought it. The more times you buy at a lower price than before, the better! Your goal is to see how many times you can continue purchasing at ever lower prices. 

You will be given the daily selling prices of a stock (positive 16-bit integers) over a period of time. You can choose to buy stock on any of the days. Each time you choose to buy, the price must be strictly lower than the previous time you bought stock. Write a program which identifies which days you should buy stock in order to maximize the number of times you buy. 

Here is a list of stock prices: 
 Day   1  2  3  4  5  6  7  8  9 10 11 12

Price 68 69 54 64 68 64 70 67 78 62 98 87


The best investor (by this problem, anyway) can buy at most four times if each purchase is lower then the previous purchase. One four day sequence (there might be others) of acceptable buys is: 
Day    2  5  6 10

Price 69 68 64 62

Input

* Line 1: N (1 <= N <= 5000), the number of days for which stock prices are given 

* Lines 2..etc: A series of N space-separated integers, ten per line except the final line which might have fewer integers. 

Output

Two integers on a single line: 
* The length of the longest sequence of decreasing prices 
* The number of sequences that have this length (guaranteed to fit in 31 bits) 

In counting the number of solutions, two potential solutions are considered the same (and would only count as one solution) if they repeat the same string of decreasing prices, that is, if they "look the same" when the successive prices are compared. Thus, two different sequence of "buy" days could produce the same string of decreasing prices and be counted as only a single solution. 

Sample Input

12
68 69 54 64 68 64 70 67 78 62
98 87

Sample Output

4 2

Source

题意:求最长下降子序列的长度以及改长度的所有种类。

#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdio>

using namespace std;
#define ll long long
#define N 6000
ll a[N], dp[N], num[N];

int main()
{
    int n;
    scanf("%d", &n);
    for(int i = 1; i <= n; ++i)
        scanf("%lld", &a[i]);
    ll maxi = 0;
    for(int i = 1; i <= n; ++i) {
        dp[i] = 0, num[i] = 0;
        int flag = 0;
        for(int j = i-1; j >= 1; --j){
            if(a[j] > a[i]) {
                if(dp[i]<dp[j]+1)
                    dp[i] = dp[j] + 1, num[i] = num[j];
                else if(dp[i]==dp[j]+1)
                    num[i] += num[j];

            }
            if(a[j] == a[i]) {//因为i~j都是比j大i以前的数和此时的j一样所有不用往前重复并且最多次数已经存在加j所以防止重复直接跳出
                flag = 1;
                break;
            }
        }
        if(!flag) {
            num[i] = max((ll)1, num[i]);
            dp[i] = max((ll)1, dp[i]);
        }
        maxi = max(maxi, dp[i]);
    }
    ll sum = 0;
    for(int i = 1; i <= n; i++) {
     //   cout << dp[i] << " " << num[i] << endl;
        if(dp[i]==maxi)
            sum += num[i];
    }
    cout << maxi << " " << sum << endl;
    return 0;
}                  

ps:这题应该要用大数的,不过poj的数据弱了一些,所有就过了,可以去试试洛谷的 点击打开链接
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值